{
 Another Lens v1.0 (c) Bjoern Ischo 1998

 Freeware with full source, Delphi 2.01, uses no third party
 components.

 For questions, suggestions etc:
 bischo6639@aol.com
 http://members.aol.com/bischo6639/
}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils,  Graphics,  Forms, inifiles,
  ExtCtrls, Menus, Controls, Classes, dialogs, clipbrd;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Image1: TImage;
    MainMenu1: TMainMenu;
    ZoomFactor1: TMenuItem;
    N11: TMenuItem;
    N21: TMenuItem;
    N41: TMenuItem;
    N81: TMenuItem;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    Copy1: TMenuItem;
    About1: TMenuItem;
    View1: TMenuItem;
    N2: TMenuItem;
    AlwaysonTop1: TMenuItem;
    LockView1: TMenuItem;
    RefreshRate1: TMenuItem;
    Slow1: TMenuItem;
    Medium1: TMenuItem;
    Fast1: TMenuItem;
    Savetofile1: TMenuItem;
    N3: TMenuItem;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Crosshairs1: TMenuItem;
    SaveDialog1: TSaveDialog;
    ToggleBorder1: TMenuItem;
    N4: TMenuItem;
    HideMenu1: TMenuItem;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure changezoomfactor(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure LockView1Click(Sender: TObject);
    procedure Medium1Click(Sender: TObject);
    procedure Fast1Click(Sender: TObject);
    procedure Slow1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure paintcrosshairs(Sender: TObject);
    procedure Crosshairs1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Savetofile1Click(Sender: TObject);
    procedure AlwaysonTop1Click(Sender: TObject);
    procedure save_data;
    procedure load_data;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormActivate(Sender: TObject);
    procedure ToggleBorder1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure HideMenu1Click(Sender: TObject);
    procedure Image1DblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1                : TForm1;
  x,y                  : integer;
  DC,dcpuffer,puffer   : hdc;
  zoom                 : integer;
  flag1                : boolean;

implementation

{$R *.DFM}

procedure TForm1.Timer1Timer(Sender: TObject);
var  position             : tpoint;
const first:boolean=true;
begin
//restore the borderstyle on first timer event:
if first then
   begin
   if flag1 then toggleborder1click(self);
   first:=false;
   end;
//first, we need to get the mouse pos
getcursorpos(position);
caption:='X:'+inttostr(position.x)+' Y:'+inttostr(position.y);
if not lockview1.checked then
begin
  //get the screen contents...
  bitblt (dcpuffer,0,0,image1.width,image1.height,dc,
         position.x-(x div 2),position.y-(y div 2),SRCCOPY);
  //finally, we copy the "stolen" screen parts
  //into image1;
  stretchblt (image1.picture.bitmap.canvas.handle,0,0,image1.width,image1.height,
         DCPuffer,0,0,x,y,SRCCOPY);
  //the image has to repaint as soon as possible....
  image1.invalidate;
end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
flag1:=false;
image1.picture.bitmap:=tbitmap.create;
zoom:=1;
FormResize(self);
//we don't want it in the taskbar... :-)
showwindow(application.handle,sw_hide);
//we need a device context for the screen
//if this would be done in the timer event,
//windows could not release dcs fast enough
//and the gdi resources would'nt like that ...
dc := createdc('DISPLAY',Nil,Nil,Nil);
dcpuffer := createcompatibledc(dc);
puffer := createcompatiblebitmap(dc,x,y);
selectobject(dcpuffer,puffer);
end;

procedure TForm1.changezoomfactor(Sender: TObject);
begin
//whatever item the user clicked, we just need the caption
zoom:=strtoint((sender as tmenuitem).caption);
//set zoom factor (basic mathematics)
x:=image1.width div zoom;
y:=image1.height div zoom;
//reset the puffer size...
puffer := createcompatiblebitmap(dc,x,y);
selectobject(dcpuffer,puffer);
(sender as tmenuitem).checked:=true;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//we don't need the device anymore
deletedc(puffer);
deletedc(dcpuffer);
deletedc(dc);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
//quite similar to changezoomfactor
x:=image1.width div zoom;
y:=image1.height div zoom;
image1.picture.bitmap.width:=image1.width;
image1.picture.bitmap.height:=image1.height;
puffer := createcompatiblebitmap(dc,x,y);
selectobject(dcpuffer,puffer);
paintcrosshairs(self);
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
close;
end;

procedure TForm1.LockView1Click(Sender: TObject);
begin
lockview1.checked:=not lockview1.checked;
end;

procedure TForm1.Medium1Click(Sender: TObject);
begin
medium1.checked:=true;
timer1.enabled:=false; timer1.interval:=100; timer1.enabled:=true;
end;

procedure TForm1.Fast1Click(Sender: TObject);
begin
fast1.checked:=true;
timer1.enabled:=false; timer1.interval:=55; timer1.enabled:=true;
end;

procedure TForm1.Slow1Click(Sender: TObject);
begin
slow1.checked:=true;
timer1.enabled:=false; timer1.interval:=300; timer1.enabled:=true;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
setwindowpos(handle,hwnd_notopmost,left,top,width,height,SWP_SHOWWINDOw);
showmessage('Another Lens'+#13+#13+'Written by Bjoern Ischo'+#13+'bischo6639@aol.com'+#13+'http://members.aol.com/bischo6639/'+#13+#13+'Freeware, enjoy it :-)');
if alwaysontop1.checked then setwindowpos(handle,hwnd_topmost,left,top,width,height,SWP_SHOWWINDOw)
end;

procedure TForm1.paintcrosshairs(Sender: TObject);
begin
bevel1.left:=(image1.width div 2)-1;
bevel1.top:=(image1.height div 2)-10;
bevel2.left:=(image1.width div 2)-10;
bevel2.top:=(image1.height div 2)-1;
end;

procedure TForm1.Crosshairs1Click(Sender: TObject);
begin
crosshairs1.checked:=not crosshairs1.checked;
bevel1.visible:=crosshairs1.checked;
bevel2.visible:=crosshairs1.checked;
paintcrosshairs(self);
end;

procedure TForm1.Copy1Click(Sender: TObject);
begin
clipboard.assign(image1.picture.bitmap);
end;

procedure TForm1.Savetofile1Click(Sender: TObject);
begin
setwindowpos(handle,hwnd_notopmost,left,top,width,height,SWP_SHOWWINDOw);
if savedialog1.execute then image1.picture.bitmap.savetofile(savedialog1.filename);
setwindowpos(handle,hwnd_topmost,left,top,width,height,SWP_SHOWWINDOw);
end;

procedure TForm1.AlwaysonTop1Click(Sender: TObject);
begin
AlwaysonTop1.checked:=not AlwaysonTop1.checked;
if AlwaysonTop1.checked then
   setwindowpos(handle,hwnd_topmost,left,top,width,height,SWP_SHOWWINDOw)
else
   setwindowpos(handle,hwnd_notopmost,left,top,width,height,SWP_SHOWWINDOw);
end;

procedure TForm1.save_data;

          function booltochar(b1:boolean):char;
          begin
          if b1 then result:='1' else result:='0';
          end;

var theini : tinifile;
    s1     : string;
begin
//we save the ini-file to the app's directory...
theini:=tinifile.create(extractfilepath(paramstr(0))+'a_lens.ini');

//assemble the datastring
s1:='';
s1:=s1+booltochar(crosshairs1.checked);
s1:=s1+booltochar(alwaysontop1.checked);
s1:=s1+inttostr(zoom)[1];
s1:=s1+inttostr(timer1.interval)[1];
s1:=s1+toggleborder1.caption[1];
s1:=s1+booltochar(view1.visible);

//write
theini.writeinteger('Position','Left',left);
theini.writeinteger('Position','Top',top);
theini.writeinteger('Position','Height',height);
theini.writeinteger('Position','width',width);
theini.writestring('Default','Settings',s1);

//get rid of the file
theini.free;
{
 Datastring structure:
 1 : crosshairs
 2 : ontop
 3 : magnification
 4 : refreshrate
 5 : border
 6 : menu
 }
end;

procedure TForm1.load_data;

          function chartobool(c1:char):boolean;
          begin
          if c1='1' then result:=true else result:=false;
          end;

var theini : tinifile;
    s1     : string;
begin
//we save the ini-file to the app's directory...
theini:=tinifile.create(extractfilepath(paramstr(0))+'a_lens.ini');

//write
left:=theini.readinteger('Position','Left',0);
top:=theini.readinteger('Position','Top',0);
height:=theini.readinteger('Position','Height',227);
width:=theini.readinteger('Position','width',208);
s1:=theini.readstring('Default','Settings','0115');

//analyze the datastring
if s1[1]='1' then crosshairs1click(self);
if s1[2]='0' then alwaysontop1click(self);
case s1[3] of
     '2' : changezoomfactor(n21);
     '4' : changezoomfactor(n41);
     '8' : changezoomfactor(n81);
end;
case s1[4] of
     '3' : slow1click(self);
     '1' : medium1click(self);
end;
if s1[5]='S' then flag1:=true; //we cannot change borderstyle onactivate;
if s1[6]='0' then hidemenu1click(self);

//get rid of the file
theini.free;
{
 Datastring structure:
 1 : crosshairs
 2 : ontop
 3 : magnification
 4 : refreshrate
 5 : border
 6 : menu
 }
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
save_data;
end;

procedure TForm1.FormActivate(Sender: TObject);
const first:boolean=true;
begin
if first then begin load_data; first:=false; timer1.enabled:=true end;

end;

procedure TForm1.ToggleBorder1Click(Sender: TObject);
begin
if borderstyle=bssizetoolwin then
   begin borderstyle:=bsnone; toggleborder1.caption:='Show Border'; end
   else
   begin borderstyle:=bssizetoolwin; toggleborder1.caption:='Hide Border'; end;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
//we move the window with the image, in case border is off...
if ssleft in shift then
   begin
   releasecapture; //restore mouse input to prevent from moving too far
   form1.perform(WM_syscommand, $F012, 0);
   end;
end;

procedure TForm1.HideMenu1Click(Sender: TObject);
begin
file1.visible:=not file1.visible;
view1.visible:=not view1.visible;

end;

procedure TForm1.Image1DblClick(Sender: TObject);
begin
hidemenu1click(self);
end;

end.
